#ifndef DGX_MATH_H
#define DGX_MATH_H

#define FIXED_FRAC	15625 /* NOTE: only works for 2^6 */
#define FIXED_PRECISION	6
#define FIXED_ONE	(1<<FIXED_PRECISION)

#define TRIG_INV_Q		15	/* 10 <= Q < 16 */
#define TRIG_INV_PRECISION	(1<<TRIG_INV_Q)
#define TRIG_INV_BUFSIZE	(TRIG_INV_PRECISION+1)

#define setQuaternion(_p_quat, _s, _i, _j, _k) \
	(_p_quat)->s = _s, \
	(_p_quat)->i = _i, \
	(_p_quat)->j = _j, \
	(_p_quat)->k = _k

struct Quaternion
{
	int s, i, j, k;
};

#define vec_add(_p_vec_a, _p_vec_b, _p_result) \
	(_p_result)->vx = (_p_vec_a)->vx + (_p_vec_b)->vx, \
	(_p_result)->vy = (_p_vec_a)->vy + (_p_vec_b)->vy, \
	(_p_result)->vz = (_p_vec_a)->vz + (_p_vec_b)->vz

#define vec_sub(_p_vec_a, _p_vec_b, _p_result) \
	(_p_result)->vx = (_p_vec_a)->vx - (_p_vec_b)->vx, \
	(_p_result)->vy = (_p_vec_a)->vy - (_p_vec_b)->vy, \
	(_p_result)->vz = (_p_vec_a)->vz - (_p_vec_b)->vz

#define vec_mult(_p_vec_a, _p_vec_b, _p_result) \
	(_p_result)->vx = ((_p_vec_a)->vx * (_p_vec_b)->vx)>>FIXED_PRECISION, \
	(_p_result)->vy = ((_p_vec_a)->vy * (_p_vec_b)->vy)>>FIXED_PRECISION, \
	(_p_result)->vz = ((_p_vec_a)->vz * (_p_vec_b)->vz)>>FIXED_PRECISION

#define vec_div(_p_vec_a, _p_vec_b, _p_result) \
	(_p_result)->vx = ((_p_vec_a)->vx / (_p_vec_b)->vx)<<FIXED_PRECISION, \
	(_p_result)->vy = ((_p_vec_a)->vy / (_p_vec_b)->vy)<<FIXED_PRECISION, \
	(_p_result)->vz = ((_p_vec_a)->vz / (_p_vec_b)->vz)<<FIXED_PRECISION

#endif

